(** http://bgb.bircd.org/pandocs.htm#memorymap
    http://imrannazar.com/GameBoy-Emulation-in-JavaScript:-Memory *)

type map = {
  rom_bank_00 : bytes; (* cartridge, 16KB *)
  rom_bank_01 : bytes; (* additional bank, 16KB *)
  vram : bytes; (* Video RAM, 8KB *)
}

let init (cartridge: Cartridge.t) =
  let open Bytes in
  {
    rom_bank_00 = sub cartridge.full_rom 0 0x4000;
    rom_bank_01 = create 0x4000;
    vram = create 0x2000;
  }
